#! /usr/bin/env python

'''This app provides the web interface for Anonplus.'''

from libs.api import VomunAPI, APIApp, register_app
from libs import kame

api = VomunAPI()

class App(APIApp):
    name = 'Anonplus Web Interface' # Public app name
    
    def setup(self):
        '''Create the web interface using a Kame server.'''
        kame.run(port=7778)
        
    def got_shutdown(self):
        '''Shutdown the Kame server and preform any other cleanup.'''
        pass # TODO: shutdown Kame
    
class IndexResponse:
    def __init__(self,args,status=200):
        self.values = args
        self.status = status

    def __str__(self):
        return str(self.status)+ " INDEX\r\n\r\n" + str(self.values)
    
class FriendsResponse:
    def __init__(self,args,status=200):
        self.values = args
        self.status = status

    def __str__(self):
        return str(self.status)+ " FRIENDS\r\n\r\n" + str(self.values)
    
class ShutdownResponse:
    def __init__(self,args,status=200):
        self.values = args
        self.status = status

    def __str__(self):
        return str(self.status)+ " SHUTDOWN\r\n\r\n" + str(self.values)

@kame.route('/friends.html')
def friends(server):
    return FriendsResponse((server.headers), status=200)

@kame.route('/shutdown.html')
def shutdown(server):
    return ShutdownResponse((server.headers), status=200)

@kame.route('/')
def index(server):
    return IndexResponse((server.headers), status=200)

register_app(App)
