'''Handles all AES (Advanced Encryption Standard) encryption. This module is
not being used yet, but it will be in a later version.'''
import Crypto
from Crypto import Random
from Crypto.Cipher import AES
import libs.encryption.base

class Encryption(libs.encryption.base.Encryption):
    '''Hold the AES encryption state.'''
    def __init__(self, key):
        self.aes = AES.new(key)
        self.rng = Random.new()

    def encrypt(self, data):
        '''Pad `data` with random bytes so that it is a multiple of 16
        bytes in length. Then encrypt the data and return it.
        '''
        return self.aes.encrypt(self.pad(data))

    def decrypt(self, data):
        '''Decrypt the data.'''
        return self.aes.decrypt(data)

    # AES only methods
    def rekey(self, key):
        '''Switch to a different key. The key should be 16 bytes in length and
        contain purely random data.
        '''
        self.aes = AES.new(key)
        
    def pad(self, data):
        count = 16 - len(data) % 16
        data += self.rng.read(count)
        return data
        