import sys
import libs.events
OUTPUT = True
LEVEL = 1

if '-v' in sys.argv:
    LEVEL = 0

class Logger(libs.events.Handler):
    '''Print events as they happen. TODO: Write to a log file'''
    def got_message(self, message):
        self._output('Got a message')
        self._output('  Message was: %s' % message.message)

    def got_connect(self, connection):
        self._output('Got a connection')

    def got_shutdown(self):
        self._output('Got shutdown request.')

    def logthis(self, message, level = 0):
        if level >= LEVEL:
            if level == 0:
                self._output(message, bullet = 'info')
            elif level == 1:
                self._output(message, bullet = 'info')
            elif level == 4:
                self._output(message, bullet = 'warn')
            elif level == 5:
                self._output(message, bullet = 'err!')
            else: # levels 2 and 3
                self._output(message)

    def _output(self, message, bullet = '*'):
        '''Print text if the OUTPUT variable is set to True.'''
        if OUTPUT:
            print('[%s] %s' % (bullet, message))

libs.events.register_handler(Logger())