#! /usr/bin/env python
'''Start the program. Load segments of the program that need to be started and
run them.'''
import atexit, time, webbrowser

from libs import browser, config, events, friends, globals, logs
from libs import storage, threadmanager
from libs.morado import morado
import tunnels
import uis.web.manager

def start():
    # Create the API Server. Used by external Applications.
    #import api.server
    # Start the API
    #api.server.start()

    morado.start()
    friends.load_friends()
    tunnels.directudp.start()
    storage.manager.start()

    uis.web.manager.start()
    atexit.register(cleanup)

def cleanup():
    events.broadcast('got_shutdown')
    threadmanager.killall()
    threadmanager.close_sockets()
    friends.save_friends()
    config.save()

def main():
    print globals['anon+']['banner'] % (globals['anon+']['VERSION'],
        globals['anon+']['BUILD'])
    print("== Warning! ==")
    print("This is an insecure beta!")
    print
    print("This software has various known weaknesses.")
    print("Please, do not depend on it to be secure!")
    print("Thank you, ~~Devs")
    print

    start()
    webbrowser.open('http://localhost:7777/')
    threadmanager.joinall()

if __name__ == '__main__':
    main()
